## This file was auto-generated by CloudCoreo CLI
## This file was automatically generated using the CloudCoreo CLI
##
## This config.rb file exists to create and maintain services not related to compute.
## for example, a VPC might be maintained using:
##
## coreo_aws_vpc_vpc "my-vpc" do
##   action :sustain
##   cidr "12.0.0.0/16"
##   internet_gateway true
## end
##

coreo_aws_iam_policy "${CLUSTER_NAME}" do
  action :sustain
  policy_name "${CLUSTER_NAME}ServerIAMPolicy"
  policy_document <<-EOH
{
  "Statement": [
    {
      "Effect": "Allow",
      "Resource": [
          "*"
      ],
      "Action": [ 
          "autoscaling:DescribeAutoScalingGroups",
          "autoscaling:DescribeAutoScalingInstances",
          "ec2:DescribeAvailabilityZones",
          "ec2:DescribeInstanceAttribute",
          "ec2:DescribeInstanceStatus",
          "ec2:DescribeInstances",
          "ec2:DescribeTags",
          "s3:*",
          "ec2:Describe*",
          "ec2:AttachNetworkInterface",
          "ec2:AttachVolume",
          "ec2:CreateTags",
          "ec2:CreateVolume",
          "ec2:RunInstances",
          "ec2:StartInstances",
          "ec2:DeleteVolume",
          "ec2:CreateSecurityGroup",
          "ec2:CreateSnapshot",
          "dynamodb:*",
          "dynamodb:Scan",
          "dynamodb:Query",
          "dynamodb:UpdateTable",
          "dynamodb:CreateTable",
          "dynamodb:BatchGetItem",
          "dynamodb:DeleteItem",
          "dynamodb:GetItem",
          "dynamodb:PutItem",
          "dynamodb:UpdateItem"
      ]
    }
  ]
}
EOH
end

coreo_aws_ec2_instance "${CLUSTER_NAME}" do
  action :define
  image_id "${CLUSTER_AMI}"
  size "${CLUSTER_SIZE}"
  security_groups ["${CLUSTER_NAME}"]
  role "${CLUSTER_NAME}"
  ssh_key "${CLUSTER_KEY}"
  disks([
         {
           :device_name => "/dev/xvdg",
           :volume_size => 25
         },
         {
           :device_name => "/dev/xvdh",
           :volume_size => 25
         },
         {
           :device_name => "/dev/xvdf",
           :volume_size => 250
         }
        ])
end

coreo_aws_ec2_autoscaling "${CLUSTER_NAME}" do
  action :sustain 
  minimum((${AUTOMATIC_ON_OFF} ? ((${AUTOMATIC_ON_HOUR}..(${AUTOMATIC_OFF_HOUR}-1)).include?(Time.new.getlocal("${TIMEZONE_OFFSET}").hour) ? ${CLUSTER_GROUP_SIZE_MIN} : 0) : ${CLUSTER_GROUP_SIZE_MIN}))
  maximum((${AUTOMATIC_ON_OFF} ? ((${AUTOMATIC_ON_HOUR}..(${AUTOMATIC_OFF_HOUR}-1)).include?(Time.new.getlocal("${TIMEZONE_OFFSET}").hour) ? ${CLUSTER_GROUP_SIZE_MAX} : 0) : ${CLUSTER_GROUP_SIZE_MAX}))
  server_definition "${CLUSTER_NAME}"
  subnet "${PRIVATE_SUBNET_NAME}"
  elbs ["${CLUSTER_NAME}-elb"]
  health_check_grace_period ${CLUSTER_HEALTH_CHECK_GRACE_PERIOD}
  upgrade({
            :upgrade_on => "dirty",
            :cooldown => ${CLUSTER_UPGRADE_COOLDOWN}
        })
  tags([
        "Name=${CLUSTER_NAME}"
       ])
end

coreo_uni_util_jsrunner "ip-splitter" do
  action :run
  data_type "text"
  json_input '{}'
  function <<-EOH
var out = "COMPOSITE::coreo_aws_ec2_autoscaling.${CLUSTER_NAME}.private_ip_addresses".replace(/,/g, "\\",\\"");
callback(out);
  EOH
end

coreo_aws_route53_record "${CLUSTER_NAME}${SUFFIX}-private" do
  action :sustain
  type "A"
  zone "${DNS_ZONE}"
  values ['COMPOSITE::coreo_uni_util_jsrunner.ip-splitter.return']
end
